require 'rubygems'
require 'chunky_png'

if RUBY_PLATFORM.include?('linux') then
  $system = "Linux"
else
  $system = "Windows"
end



module ChunkyPNG
  class Image
        def bitmapa(znak)
      bitmapa = case znak
        when "0" then [
          "..####..",
          ".##..##.",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          ".##..##.",
          "..####..",]
        when "1" then [
          "...##...",
          "..###...",
          "#####...",
          "...##...",
          "...##...",
          "...##...",
          "...##...",
          "...##...",
          "...##...",
          "...##...",
          "...##...",
          "...##...",
          "...##...",
          "########",]
        when "2" then [
          "..####..",
          ".##..##.",
          "##....##",
          "##....##",
          "......##",
          "......##",
          ".....##.",
          "....##..",
          "...##...",
          "..##....",
          ".##.....",
          "##......",
          "##......",
          "########",]
        when "3" then [
          "..####..",
          ".##..##.",
          "##....##",
          "##....##",
          "......##",
          "......##",
          "..#####.",
          "......##",
          "......##",
          "......##",
          "##....##",
          "##....##",
          ".##..##.",
          "..####..",]
        when "4" then [
          "...##...",
          "...##...",
          "..##....",
          "..##....",
          "..##....",
          ".##.....",
          ".##.....",
          ".##.##..",
          "##..##..",
          "##..##..",
          "##..##..",
          "########",
          "....##..",
          "....##..",]
        when "5" then [
          "########",
          "##......",
          "##......",
          "##......",
          "##......",
          "######..",
          ".....##.",
          "......##",
          "......##",
          "......##",
          "##....##",
          "##....##",
          ".##..##.",
          "..####..",]
        when "6" then [
          "....####",
          "...##...",      
          "..##....",
          ".##.....",
          ".##.....",
          "##......",
          "######..",
          "##...##.",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          ".##..##.",
          "..####..",]
        when "7" then [
          "########",
          "......##",
          "......##",
          "......##",
          ".....##.",
          ".....##.",
          ".....##.",
          "....##..",
          "....##..",
          "....##..",
          "...##...",
          "...##...",
          "...##...",
          "...##...",]
        when "8" then [
          "..####..",
          ".##..##.",
          "##....##",
          "##....##",
          "##....##",
          ".##..##.",
          "..####..",
          ".##..##.",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          ".##..##.",
          "..####..",]    
        when "9" then [
          "..####..",
          ".##..##.",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          "##....##",
          ".##...##",
          "..######",
          ".....##.",
          ".....##.",
          "....##..",
          "...##...",
          "####....",]
        when ":" then [
          "........",
          "........",
          "........",
          "........",
          "........",
          "...##...",
          "...##...",
          "........",
          "........",
          "........",
          "........",
          "........",
          "...##...",
          "...##...",]  
        when "." then [
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "...##...",
          "...##...",]  
        when "-" then [
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "########",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",]  
        when " " then [
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",
          "........",]  
        end  
    end

    def outTextXY(napis, x, y)
      litera = 0
      napis.chars.each do |znak|
        y_ = 1
        bitmapa(znak).each do |linia|
          x_ = 1
          linia.split('').each do |pixel|
            self[x + litera * 10 + x_, y + y_ ] = ChunkyPNG::Color('black') if pixel == "#"
            x_ = x_ + 1
          end
          y_ = y_ + 1
        end
        litera = litera +1
      end
    end
    
    def kreska(x,y1,y2,t1,t2,min,max)
      y1 = y1* $skala
      y2 = y2 * $skala
      t1 = min if t1 < min 
      t1 = max if t1 > max
      t2 = min if t2 < min
      t2 = max if t2 > max
      delta_y = y2-y1
      delta_t = t2-t1
      przyrost_t = delta_t / delta_y
      if y1>y2 then
        puts "y1>y2?"
        exit
      end
      y1.upto(y2) do |y|
        t = t1+(y-y1)*przyrost_t
        odleglosc_od_min = t - min
        odleglosc_od_min = odleglosc_od_min / (max-min)


        czerwony, zielony, niebieski = kolor(przedzial(t,min,max))
        self[x, $y_res-y] = ChunkyPNG::Color.rgba(czerwony, zielony, niebieski, 255)
      end
      
      
      
    end
  end
end

#tablica z gama kolorystyczna RGB
$lut = [[255, 237, 237], [255, 224, 224], [255, 209, 209], [255, 193, 193], [255, 176, 176], [255, 159, 159], [255, 142, 142], [255, 126, 126], [255, 110, 110], [255, 94, 94], [255, 81, 81], [255, 67, 67], [255, 56, 56], [255, 46, 46], [255, 37, 37], [255, 29, 29], [255, 23, 23], [255, 18, 18], [255, 14, 14], [255, 11, 11], [255, 8, 8], [255, 6, 6], [255, 5, 5], [255, 3, 3], [255, 2, 2], [255, 2, 2], [255, 1, 1], [255, 1, 1], [255, 0, 0], [255, 0, 0], [255, 0, 0], [255, 0, 0], [255, 0, 0], [255, 0, 0], [255, 0, 0], [255, 0, 0], [255, 1, 0], [255, 4, 0], [255, 6, 0], [255, 10, 0], [255, 14, 0], [255, 18, 0], [255, 22, 0], [255, 26, 0], [255, 31, 0], [255, 36, 0], [255, 41, 0], [255, 45, 0],[255, 51, 0], [255, 57, 0], [255, 62, 0], [255, 68, 0], [255, 74, 0], [255, 81, 0], [255, 86, 0], [255, 93, 0], [255, 99, 0], [255, 105, 0], [255, 111, 0], [255, 118, 0], [255, 124, 0], [255, 131, 0], [255, 137, 0], [255, 144, 0], [255, 150, 0], [255, 156, 0], [255, 163, 0], [255, 169, 0], [255, 175, 0], [255, 181, 0], [255, 187, 0], [255, 192, 0], [255, 198, 0], [255, 203, 0], [255, 208, 0], [255, 213, 0], [255, 218, 0], [255, 222, 0], [255, 227, 0], [255, 232, 0], [255, 235, 0], [255, 238, 0], [255, 242, 0], [255, 245, 0], [255, 247, 0], [255, 250, 0], [255, 251, 0], [253, 252, 0], [250, 252, 1], [248, 252, 2], [244, 252, 2], [241, 252, 3], [237, 252, 3], [233, 252, 3], [229, 252, 4], [225, 252, 4], [220, 252, 5], [216, 252, 5], [211, 252, 6], [206, 252, 7], [201, 252, 7], [197, 252, 8], [191, 251, 8], [185, 249, 9], [180, 247, 9], [174, 246, 10], [169, 244, 11], [164, 242, 11], [158, 240, 12], [151, 238, 13], [146, 236, 14], [140, 233, 14], [134, 231, 15], [128, 228, 16], [122, 226, 17], [116, 223, 18], [110, 221, 19], [105, 218, 20], [99, 216, 21], [93, 214, 22], [88, 211, 23], [82, 209, 24], [76, 207, 25], [71, 204, 26], [66, 202, 28], [60, 200, 30], [55, 198, 31], [50, 196, 33], [45, 194, 34], [40, 191, 35], [36, 190, 37], [31, 188, 39], [27, 187, 40], [23, 185, 43], [19, 184, 44], [15, 183, 46], [12, 182, 48], [9, 181, 51], [6, 181, 53], [3, 180, 55], [1, 180, 57], [0, 180, 60], [0, 180, 62], [0, 180, 65], [0, 181, 68], [0, 182, 70], [0, 182, 74], [0, 183, 77], [0, 184, 80], [0, 184, 84], [0, 186, 88], [0, 187, 92], [0, 188, 95], [0, 190, 99], [0, 191, 104], [0, 193, 108], [0, 194, 112], [0, 196, 116], [0, 198, 120], [0, 200, 125], [0, 201, 129], [0, 203, 134], [0, 205, 138], [0, 207, 143], [0, 209, 147], [0, 211, 151], [0, 213, 156], [0, 215, 160], [0, 216, 165], [0, 219, 171], [0, 222, 178], [0, 224, 184], [0, 227, 190], [0, 229, 197], [0, 231, 203], [0, 233, 209], [0, 234, 214], [0, 234, 220], [0, 234, 225], [0, 234, 230], [0, 234, 234], [0, 234, 238], [0, 234, 242], [0, 234, 246], [0, 234, 248], [0, 234, 251], [0, 234, 254], [0, 234, 255], [0, 232, 255], [0, 228, 255], [0, 224, 255], [0, 219, 255], [0, 214, 254], [0, 208, 252], [0, 202, 250], [0, 195, 247], [0, 188, 244], [0, 180, 240], [0, 173, 236], [0, 164, 232], [0, 156, 228], [0, 147, 222], [0, 139, 218], [0, 130, 213], [0, 122, 208], [0, 117, 205], [0, 112, 203], [0, 107, 199], [0, 99, 196], [0, 93, 193], [0, 86, 189], [0, 78, 184], [0, 71, 180], [0, 65, 175], [0, 58, 171], [0, 52, 167], [0, 46, 162], [0, 40, 157], [0, 35, 152], [0, 30, 147], [0, 26, 142], [0, 22, 136], [0, 18, 131], [0, 15, 126], [0, 12, 120], [0, 9, 115], [1, 8, 110], [1, 6, 106], [1, 5, 101], [2, 4, 97], [3, 4, 92], [4, 5, 89], [5, 5, 85], [6, 6, 82], [7, 7, 79], [8, 8, 77], [10, 10, 77], [12, 12, 77], [14, 14, 76], [16, 16, 74], [19, 19, 73], [21, 21, 72], [24, 24, 71], [26, 26, 69], [29, 29, 70], [32, 32, 69], [35, 35, 68], [37, 37, 67], [40, 40, 67], [42, 42, 65], [44, 44, 65], [46, 46, 64], [48, 48, 63], [49, 50, 62], [51, 51, 61], [53, 52, 61]]

def kolor(wartosc)
  if $paleta == "_rb" then
    czerwony = (255 * wartosc).to_i
    zielony = 0
    niebieski = 255 - czerwony
  end
  if $paleta == "_rgb" then
    indeks = 255 - wartosc * 256.0
    #indeks = 255 - wartosc * (256.0-10) + 10 #bez bialego maksymalnego koloru
    indeks = 255 if indeks > 255
    indeks = 0 if indeks < 0
    czerwony, zielony, niebieski = $lut[indeks]
  end
  return czerwony, zielony, niebieski
end


def przedzial(wartosc, poczatek, koniec)
   wartosc = poczatek if wartosc < poczatek
   wartosc = koniec if wartosc > koniec
   zakres = koniec - poczatek
   
   (wartosc - poczatek) / (koniec.to_f - poczatek)
end


def log(tekst)
  puts tekst
  if $system == "Linux" then
    out = File.new("/RPi/ruby/bufor_grafika_log.txt",'a')
  else
    out = File.new("bufor_grafika_log.txt",'a')
  end
  out.print "#{Time.now.strftime('%Y-%m-%d %H:%M:%S.%L')} #{tekst}"
  out.print("\r\n")
  out.close
end

def sekundy_na_czas(i)
  h = (i / 3600).to_i
  i = i - 3600 * h
  m = (i / 60).to_i
  i = i - 60 * m
  s = i
  sprintf("%.2i",h)+':'+sprintf("%.2i",m)+':'+sprintf("%.2i",s)
end


def generuj_wykres(plik,t_min,t_max)
  image = ChunkyPNG::Image.new $x_res+2, $y_res, ChunkyPNG::Color('white')
  puts "podpisujemy godziny"
  (0..23).each do |h| 
    x = h * 60 
    napis = h.to_s
    napis = "0" + napis if h < 10 
    image.outTextXY(napis, x + 20,$y_res-73)
  end

  puts "rysujemy pionowe kreski godzinowe"
  (1..23).each do |h| 
    x = h * 60 
    image.line(x, 1, x, $y_res-73, ChunkyPNG::Color('black'))
  end

  puts "rysujemy poziome kreski na wysokosciach termometrow"
  16.step(160,16) do |n|
    y = n * $skala
    y = y - (16 * $skala) +1
    image.line(0, y, $x_res+2, y, ChunkyPNG::Color('black'))
  end
  
  
  
  #image.outTextXY(t_min.to_s+" - "+t_max.to_s,0,$y_res-50)
  #image.outTextXY(File.basename(plik).split('.')[0].sub('_dane','').sub('.txt','').sub('bufor_',''),0,$y_res-30)
  
  puts "rysujemy skale kolorystyczna"
  1.upto($x_res-1) do |x|
    t = przedzial(x,1,$x_res) * (t_max-t_min) + t_min
    image.kreska(x,5,10,t,t,t_min,t_max)
  end

  puts "podpisujemy skale kolorystyczna"
  x_zajete = 0
  (t_min.to_i).upto(t_max.to_i) do |t|
    x = przedzial(t,t_min,t_max) * $x_res
    if x > x_zajete then
      x_zajete = x + 27
      image.outTextXY(t.to_s,x,$y_res-20) if x < ($x_res - 20)
    end
  end
  
  File.foreach(plik) do |line|
    line.gsub!('=',';')
    t = line.split(';')
    if t[9].to_f + t[11].to_f + t[13].to_f + t[15].to_f + t[17].to_f + t[19].to_f + t[21].to_f + t[23].to_f + t[25].to_f + t[27].to_f == t[29].to_f then
      godzina = t[3].to_i
      minuta = t[4].to_i
      sekunda = godzina * 60 + minuta
      xx = sekunda

      t_160 = t[9].to_f
      t_144 = t[11].to_f
      t_128 = t[13].to_f
      t_112 = t[15].to_f
      t_96 = t[17].to_f
      t_80 = t[19].to_f
      t_64 = t[21].to_f
      t_48 = t[23].to_f
      t_32 = t[25].to_f 
      t_16 = t[27].to_f
      
      image.kreska(xx,144,160,t_144,t_160,t_min,t_max)
      image.kreska(xx,128,144,t_128,t_144,t_min,t_max)
      image.kreska(xx,112,128,t_112,t_128,t_min,t_max)
      image.kreska(xx,96,112,t_96,t_112,t_min,t_max)
      image.kreska(xx,80,96,t_80,t_96,t_min,t_max)
      image.kreska(xx,64,80,t_64,t_80,t_min,t_max)
      image.kreska(xx,48,64,t_48,t_64,t_min,t_max)
      image.kreska(xx,32,48,t_32,t_48,t_min,t_max)
      image.kreska(xx,16,32,t_16,t_32,t_min,t_max)
    end
  end
  
  png = File.basename(plik).split('.')[0].sub('_dane','').sub('.txt','')
  puts png
  if $system == "Linux" then
    image.save("/var/www/bufor/png/#{png}#{$paleta}.png")
  else
    image.save("#{png}#{$paleta}.png")
  end
  log "zapisujemy wynik jako #{png}#{$paleta}.png"

end

def szukaj_min_max(plik)
  temperatury = []
  File.foreach(plik) do |line|
    line.gsub!('=',';')
    t = line.split(';')
    if t[9].to_f + t[11].to_f + t[13].to_f + t[15].to_f + t[17].to_f + t[19].to_f + t[21].to_f + t[23].to_f + t[25].to_f + t[27].to_f == t[29].to_f then
      temperatury << t[9].to_f
      temperatury << t[11].to_f
      temperatury << t[13].to_f
      temperatury << t[15].to_f
      temperatury << t[17].to_f
      temperatury << t[19].to_f
      temperatury << t[21].to_f
      temperatury << t[23].to_f
      temperatury << t[25].to_f 
      temperatury << t[27].to_f   
    end
  end
  temperatury.minmax
end







$skala = 5
$x_res = 1441
$y_res = 160 * $skala + 1
$min = 999
$max = -999











start = Time.now
log ""
log "===================================================="
log "============  uruchomienie programu ================"
log "===================================================="
if $system == "Linux" then
  wszystkie_pliki = Dir["/RPi/ruby/bufor_*_dane.txt"]
else
  wszystkie_pliki = Dir["bufor_*_dane.txt"]
end

data_files = []

log "wszystkie pliki z danymi: #{wszystkie_pliki.inspect}"

wszystkie_pliki.each do |file_name|
  #log "nazwa= #{file_name}"
  
  #log "data modyfikacji: #{File.mtime(file_name).strftime('%Y-%m-%d %H:%M:%S')}"
  jak_stary = Time.now - File.mtime(file_name)
  #log "jego wiek to: #{jak_stary} (s) = #{sekundy_na_czas(jak_stary)} (hh:mm:ss)"

  if $system == "Linux" then
    max_time = 120
  else
    max_time = 999999
  end

  if File.size(file_name) > 100 and jak_stary < max_time then #120s 
    #log "dodajemy plik #{file_name} do listy wybranych"
    data_files << file_name
  else
    #log "pliku #{file_name} nie dodajemy do listy wybranych"
  end
end

log "pliki z danymi wybrane do dalszej obrobki: #{data_files.inspect}"


data_files.each do |nazwa|
  puts "przetwarzamy: #{nazwa}"
  min, max = szukaj_min_max(nazwa)
  #min, max = 20, 90
  #$paleta = "_rb"
  #puts "generujemy wykres #{nazwa} - #{$paleta}"
  #generuj_wykres(nazwa,20,90)
  $paleta = "_rgb"
  puts "generujemy wykres #{nazwa} - #{$paleta}"
  generuj_wykres(nazwa,min,max)
end

log "koniec, sumaryczny czas pracy: #{Time.now-start} s"

